74. 搜索二维矩阵

一、题目描述

编写一个高效的算法来判断 m x n 矩阵中,是否存在一个目标值。该矩阵具有如下特性:

每行中的整数从左到右按升序排列。
每行的第一个整数大于前一行的最后一个整数。

示例 1:

输入:
matrix = [
[1, 3, 5, 7],
[10, 11, 16, 20],
[23, 30, 34, 50]
]
target = 3
输出: true

示例 2:

输入:
matrix = [
[1, 3, 5, 7],
[10, 11, 16, 20],
[23, 30, 34, 50]
]
target = 13
输出: false

二、解题思路 & 代码

2.1 二分法

class Solution:
def searchMatrix(self, matrix: List[List[int]], target: int) -> bool:
m = len(matrix)
if m == 0:
return False
n = len(matrix[0])

#二分查找
left, right = 0, m * n - 1
while left <= right:
pivot_idx = (left + right) // 2
pivot_element = matrix[pivot_idx // n][pivot_idx % n]
if target == pivot_element:
return True
else:
if target < pivot_element:
right = pivot_idx - 1
else:
left = pivot_idx + 1
return False

复杂度分析

  1. 时间复杂度 : 由于是标准的二分查找,时间复杂度为【LeetCode】74. 搜索二维矩阵  & 240. 搜索二维矩阵 II_数据结构
  2. 空间复杂度 :【LeetCode】74. 搜索二维矩阵  & 240. 搜索二维矩阵 II_算法_02

参考:
​​​LeetCode官方题解​

2.2 利用升序特性改进版

从左下角开始找,只走两个方向 右和上复杂度O(m+n)

class Solution {
public boolean searchMatrix(int[][] matrix, int target) {
int m = matrix.length;
if(m == 0) return false;
int n = matrix[0].length;
int i = m-1;
int j = 0;
while(i >= 0 && j < n) {
if(matrix[i][j] == target) {
return true;
} else if(matrix[i][j] > target) {
i--;
} else {
j++;
}
}
return false;
}
}

==========================================================

==========================================================

240. 搜索二维矩阵 II

一、 题目描述

编写一个高效的算法来搜索 m x n 矩阵 matrix 中的一个目标值 target。该矩阵具有以下特性:

每行的元素从左到右升序排列。
每列的元素从上到下升序排列。

示例:

现有矩阵 matrix 如下:

[
[1, 4, 7, 11, 15],
[2, 5, 8, 12, 19],
[3, 6, 9, 16, 22],
[10, 13, 14, 17, 24],
[18, 21, 23, 26, 30]
]
给定 target = 5,返回 true。

给定 target = 20,返回 false。

二、解题思路 & 代码

这个二维数组就类似一棵排序二叉树,对于每一个数来说,上方的数都小于它,右边的数都大于它,所以把左下角作为根节点开始查找!

class Solution:
def searchMatrix(self, matrix, target):
# an empty matrix obviously does not contain `target` (make this check
# because we want to cache `width` for efficiency's sake)
if len(matrix) == 0 or len(matrix[0]) == 0:
return False

# cache these, as they won't change.
height = len(matrix)
width = len(matrix[0])

# start our "pointer" in the bottom-left
row = height-1
col = 0

while col < width and row >= 0:
if matrix[row][col] > target:
row -= 1
elif matrix[row][col] < target:
col += 1
else: # found it
return True

return False

复杂度分析

  1. 时间复杂度:O(n+m)。
    时间复杂度分析的关键是注意到在每次迭代(我们不返回 true)时,行或列都会精确地递减/递增一次。由于行只能减少 m 次,而列只能增加 n 次,因此在导致 while 循环终止之前,循环不能运行超过 n+m 次。因为所有其他的工作都是常数,所以总的时间复杂度在矩阵维数之和中是线性的。
  2. 空间复杂度:O(1),因为这种方法只处理几个指针,所以它的内存占用是恒定的。

参考:
​​​leetCode官方题解​